<h1>Pipe Personalizados</h1>
<p>Pipe creados por {{'nosotros' | upper : enMayusculas }}</p>

<p-toolbar>
    <div class="p-toolbar-group-left">
    </div>
    <div class="p-toolbar-group-right">
        <button pButton (click)="changeCase()" label="toogle mayúsculas" class="mr-1 p-button-warning"></button>
        <p-button icon="pi pi-sort" label="Por nombre" (onClick)="changeOrder( 'nombre' )" styleClass="mr-1"></p-button>
        <p-button icon="pi pi-sort" label="Vuela" (onClick)="changeOrder( 'vuela' )" styleClass="mr-1 p-button-success"></p-button>
        <p-button icon="pi pi-sort" label="Por color" (onClick)="changeOrder( 'color' )" styleClass="mr-1 p-button-help"></p-button>
    </div>
</p-toolbar>

<div class="grid">
    <div class="col">
        <p-table [value]="heroes | ordenar: changeBy">
            <ng-template pTemplate="header">
                <tr>
                    <th>Nombre</th>
                    <th>Vuela</th>
                    <th>Color</th>
                </tr>
            </ng-template>
            <ng-template pTemplate="body" let-heroe>
                <tr>
                    <td>{{heroe.nombre}}</td>
                    <td>{{heroe.vuela | fly | titlecase}}</td>
                    <td>{{heroe.color}}</td>
                </tr>
            </ng-template>
        </p-table>
    </div>
</div>

<br>
<hr>
<br>

<div class="grid">
    <div class="col">
        <!-- slice:0 => nos permite enviarle una copia del arreglo heroes original para evitar su mutacion cuando se realice el ordenamiento respectivo -->
        <p-table [value]="heroes | slice:0">
            <ng-template pTemplate="header">
                <tr>
                    <th pSortableColumn="nombre">Nombre<p-sortIcon field="nombre"></p-sortIcon></th>
                    <th pSortableColumn="vuela">Vuela<p-sortIcon field="vuela"></p-sortIcon></th>
                    <th pSortableColumn="color">Color<p-sortIcon field="color"></p-sortIcon></th>
                </tr>
            </ng-template>
            <ng-template pTemplate="body" let-heroe>
                <tr>
                    <td>{{heroe.nombre}}</td>
                    <td>{{heroe.vuela | fly | titlecase}}</td>
                    <td>{{heroe.color}}</td>
                </tr>
            </ng-template>
        </p-table>
    </div>
</div>